
%global pkg_name hledger-lib
%global pkgver %{pkg_name}-%{version}

%global cassavamegaparsec cassava-megaparsec-2.0.4
%global timeit timeit-2.0
%global breakpoint breakpoint-0.1.2.1
%global pager pager-0.1.1.0
%global textansi text-ansi-0.2.1.1
%global textbuilder text-builder-0.6.7
%global textbuilderdev text-builder-dev-0.3.3.2
%global deferredfolds deferred-folds-0.9.18.3
%global isomorphismclass isomorphism-class-0.1.0.9
%global subpkgs %{cassavamegaparsec} %{timeit} %{breakpoint} %{pager} %{deferredfolds} %{isomorphismclass} %{textbuilderdev} %{textbuilder} %{textansi}

%bcond_with tests

Name:           ghc-%{pkg_name}
Version:        1.30
Release:    1%{?dist}
Summary:        A reusable library providing the core functionality of hledger

License:        GPL-3.0-or-later
Url:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkgver}/%{pkgver}.tar.gz
Source1:        https://hackage.haskell.org/package/%{cassavamegaparsec}/%{cassavamegaparsec}.tar.gz
Source2:        https://hackage.haskell.org/package/%{timeit}/%{timeit}.tar.gz
Source3:        https://hackage.haskell.org/package/%{breakpoint}/%{breakpoint}.tar.gz
Source4:        https://hackage.haskell.org/package/%{pager}/%{pager}.tar.gz
Source5:        https://hackage.haskell.org/package/%{textansi}/%{textansi}.tar.gz
Source6:        https://hackage.haskell.org/package/%{textbuilder}/%{textbuilder}.tar.gz
Source7:        https://hackage.haskell.org/package/%{textbuilderdev}/%{textbuilderdev}.tar.gz
Source8:        https://hackage.haskell.org/package/%{deferredfolds}/%{deferredfolds}.tar.gz
Source9:        https://hackage.haskell.org/package/%{isomorphismclass}/%{isomorphismclass}.tar.gz
Source10:       https://hackage.haskell.org/package/%{pkgver}/%{pkg_name}.cabal#/%{pkgver}.cabal
Patch0:         pager-exec-license.patch

BuildRequires:  dos2unix
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros-extra
BuildRequires:  ghc-Decimal-devel
BuildRequires:  ghc-Glob-devel
BuildRequires:  ghc-aeson-devel
BuildRequires:  ghc-aeson-pretty-devel
BuildRequires:  ghc-ansi-terminal-devel
BuildRequires:  ghc-array-devel
BuildRequires:  ghc-base-devel
BuildRequires:  ghc-base-compat-devel
BuildRequires:  ghc-blaze-markup-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-call-stack-devel
BuildRequires:  ghc-cassava-devel
BuildRequires:  ghc-cmdargs-devel
BuildRequires:  ghc-colour-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-data-default-devel
BuildRequires:  ghc-deepseq-devel
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-doclayout-devel
BuildRequires:  ghc-extra-devel
BuildRequires:  ghc-file-embed-devel
BuildRequires:  ghc-filepath-devel
BuildRequires:  ghc-hashtables-devel
BuildRequires:  ghc-megaparsec-devel
BuildRequires:  ghc-microlens-devel
BuildRequires:  ghc-microlens-th-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-parser-combinators-devel
BuildRequires:  ghc-pretty-simple-devel
BuildRequires:  ghc-regex-tdfa-devel
BuildRequires:  ghc-safe-devel
BuildRequires:  ghc-tabular-devel
BuildRequires:  ghc-tasty-devel
BuildRequires:  ghc-tasty-hunit-devel
BuildRequires:  ghc-template-haskell-devel
BuildRequires:  ghc-terminal-size-devel
BuildRequires:  ghc-text-devel
BuildRequires:  ghc-time-devel
BuildRequires:  ghc-transformers-devel
BuildRequires:  ghc-uglymemo-devel
BuildRequires:  ghc-unordered-containers-devel
BuildRequires:  ghc-utf8-string-devel
%if %{with ghc_prof}
BuildRequires:  ghc-Decimal-prof
BuildRequires:  ghc-Glob-prof
BuildRequires:  ghc-aeson-prof
BuildRequires:  ghc-aeson-pretty-prof
BuildRequires:  ghc-ansi-terminal-prof
BuildRequires:  ghc-array-prof
BuildRequires:  ghc-base-prof
BuildRequires:  ghc-base-compat-prof
BuildRequires:  ghc-blaze-markup-prof
BuildRequires:  ghc-bytestring-prof
BuildRequires:  ghc-call-stack-prof
BuildRequires:  ghc-cassava-prof
BuildRequires:  ghc-cmdargs-prof
BuildRequires:  ghc-colour-prof
BuildRequires:  ghc-containers-prof
BuildRequires:  ghc-data-default-prof
BuildRequires:  ghc-deepseq-prof
BuildRequires:  ghc-directory-prof
BuildRequires:  ghc-doclayout-prof
BuildRequires:  ghc-extra-prof
BuildRequires:  ghc-file-embed-prof
BuildRequires:  ghc-filepath-prof
BuildRequires:  ghc-hashtables-prof
BuildRequires:  ghc-megaparsec-prof
BuildRequires:  ghc-microlens-prof
BuildRequires:  ghc-microlens-th-prof
BuildRequires:  ghc-mtl-prof
BuildRequires:  ghc-parser-combinators-prof
BuildRequires:  ghc-pretty-simple-prof
BuildRequires:  ghc-regex-tdfa-prof
BuildRequires:  ghc-safe-prof
BuildRequires:  ghc-tabular-prof
BuildRequires:  ghc-tasty-prof
BuildRequires:  ghc-tasty-hunit-prof
BuildRequires:  ghc-template-haskell-prof
BuildRequires:  ghc-terminal-size-prof
BuildRequires:  ghc-text-prof
BuildRequires:  ghc-time-prof
BuildRequires:  ghc-transformers-prof
BuildRequires:  ghc-uglymemo-prof
BuildRequires:  ghc-unordered-containers-prof
BuildRequires:  ghc-utf8-string-prof
%endif
%if %{with tests}
BuildRequires:  ghc-doctest-devel
%endif
BuildRequires:  ghc-vector-devel
%if %{with ghc_prof}
BuildRequires:  ghc-vector-prof
%endif
BuildRequires:  ghc-ghc-devel
BuildRequires:  ghc-haskeline-devel
%if %{with ghc_prof}
BuildRequires:  ghc-ghc-prof
BuildRequires:  ghc-haskeline-prof
%endif
BuildRequires:  ghc-conduit-devel
BuildRequires:  ghc-conduit-extra-devel
BuildRequires:  ghc-process-devel
BuildRequires:  ghc-resourcet-devel
BuildRequires:  ghc-terminfo-devel
BuildRequires:  ghc-unix-devel
%if %{with ghc_prof}
BuildRequires:  ghc-conduit-prof
BuildRequires:  ghc-conduit-extra-prof
BuildRequires:  ghc-process-prof
BuildRequires:  ghc-resourcet-prof
BuildRequires:  ghc-terminfo-prof
BuildRequires:  ghc-unix-prof
%endif
BuildRequires:  ghc-split-devel
%if %{with ghc_prof}
BuildRequires:  ghc-split-prof
%endif
BuildRequires:  ghc-foldl-devel
BuildRequires:  ghc-hashable-devel
BuildRequires:  ghc-primitive-devel
BuildRequires:  ghc-vector-devel
%if %{with ghc_prof}
BuildRequires:  ghc-foldl-prof
BuildRequires:  ghc-hashable-prof
BuildRequires:  ghc-primitive-prof
BuildRequires:  ghc-vector-prof
%endif
BuildRequires:  ghc-hashable-devel
BuildRequires:  ghc-primitive-devel
BuildRequires:  ghc-vector-devel
%if %{with ghc_prof}
BuildRequires:  ghc-hashable-prof
BuildRequires:  ghc-primitive-prof
BuildRequires:  ghc-vector-prof
%endif

%description
A reusable library containing hledger's core functionality. This is used by
most hledger* packages so that they support the same common file formats,
command line options, reports etc.

hledger is a robust, cross-platform set of tools for tracking money, time, or
any other commodity, using double-entry accounting and a simple, editable file
format, with command-line, terminal and web interfaces. It is a Haskell rewrite
of Ledger, and one of the leading implementations of Plain Text Accounting.
Read more at: <https://hledger.org>.


%package devel
Summary:        Haskell %{pkg_name} library development files
Provides:       %{name}-static = %{version}-%{release}
Provides:       %{name}-static = %{version}-%{release}
%if %{defined ghc_version}
Requires:       ghc-compiler = %{ghc_version}
%endif
Requires:       %{name} = %{version}-%{release}

%description devel
This package provides the Haskell %{pkg_name} library development files.


%if %{with haddock}
%package doc
Summary:        Haskell %{pkg_name} library documentation
BuildArch:      noarch
Requires:       ghc-filesystem

%description doc
This package provides the Haskell %{pkg_name} library documentation.
%endif


%if %{with ghc_prof}
%package prof
Summary:        Haskell %{pkg_name} profiling library
Requires:       %{name}-devel = %{version}-%{release}
Supplements:    (%{name}-devel and ghc-prof)

%description prof
This package provides the Haskell %{pkg_name} profiling library.
%endif


%global main_version %{version}

%if %{defined ghclibdir}
%ghc_lib_subpackage -l MIT %{cassavamegaparsec}
%ghc_lib_subpackage -l BSD-3-Clause %{timeit}
%ghc_lib_subpackage -l MIT %{breakpoint}
%ghc_lib_subpackage -l BSD-2-Clause %{pager}
%ghc_lib_subpackage -l BSD-3-Clause %{textansi}
%ghc_lib_subpackage -l MIT %{textbuilder}
%ghc_lib_subpackage -l MIT %{textbuilderdev}
%ghc_lib_subpackage -l MIT %{deferredfolds}
%ghc_lib_subpackage -l MIT %{isomorphismclass}
%endif

%global version %{main_version}


%prep
%setup -q -n %{pkgver} -a1 -a2 -a3 -a4 -a5 -a6 -a7 -a8 -a9
dos2unix -k -n %{SOURCE10} %{pkg_name}.cabal
(
cd %{cassavamegaparsec}
cabal-tweak-dep-ver vector 0.13 0.14
)
(
cd %{pager}
%patch -P0 -p1
)


%build
%ghc_libs_build %{subpkgs}
%ghc_lib_build


%install
%ghc_libs_install %{subpkgs}
%ghc_lib_install


%check
%if %{with tests}
%cabal_test
%endif


%files -f %{name}.files
%license LICENSE


%files devel -f %{name}-devel.files
%doc CHANGES.md README.md


%if %{with haddock}
%files doc -f %{name}-doc.files
%license LICENSE
%endif


%if %{with ghc_prof}
%files prof -f %{name}-prof.files
%endif


%changelog
* Thu Aug 08 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.30-1
- initial build
